indexing

	description:

		"Eiffel types which appear in constraints of formal %
		%generic parameters. The names of the types have not %
		%been resolved yet, they may be names of classes or %
		%of formal generic parameters."

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 2003, Eric Bezault and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2003/10/21 16:24:38 $"
	revision: "$Revision: 1.2 $"

deferred class ET_CONSTRAINT_TYPE

inherit

	ET_CONSTRAINT_TYPE_ITEM
		redefine
			resolved_syntactical_constraint
		end

	ET_SHARED_TOKEN_CONSTANTS
		export {NONE} all end

feature -- Access

	type: ET_CONSTRAINT_TYPE is
			-- Type
		do
			Result := Current
		end

feature -- Conversion

	resolved_syntactical_constraint (a_formals: ET_FORMAL_PARAMETER_LIST;
		a_parser: ET_EIFFEL_PARSER_SKELETON): ET_TYPE is
			-- Version of current type, appearing in the constraint of
			-- one of the formal generic parameters in `a_formals', where
			-- class names and formal generic parameter names have been
			-- resolved (i.e. replaced by the corresponding Class_type,
			-- Tuple_type and Formal_parameter_type)
		deferred
		end

end
